// Boot.java                                    MM 2005

/**
 * Boot, Beispiel fuer abstrakte Klassen.
 */
public abstract class Boot
{
/*---------------------------------------------------*/
                                     // Klassenvariable
/**
 * Gesamtzahl der vorhandenen Boote.
 */
  private static int anzahl = 0;

/*---------------------------------------------------*/
                                    // Instanzvariablen
/**
 * Bootsname.
 */
  private String name;

/**
 * Bootsnummer.
 */
  private int nummer;

/*---------------------------------------------------*/
                                       // Konstruktoren
/**
 * Konstuktor, erzeugt neues Boot mit Namen.
 * @param name Name des Bootes
 */
  public Boot( String name)
  {
    incAnzahl();
    nummer = anzahl;
    setName( name);
  }

/**
 * Konstuktor, erzeugt neues Boot.
 */
  public Boot()
  {
    this( "");                  // ruft Konstruktor auf
  }

/*---------------------------------------------------*/
                                      // Klassenmethode
/**
 * Klassenmethode, Erhoehen der Gesamtzahl der Boote.
 */
  public static void incAnzahl()
  {
    anzahl++;
  }

/*---------------------------------------------------*/
                                     // Instanzmethoden
/**
 * Veraendern des Bootsnamens.
 * @param name Bootsname
 */
  public void setName( String name)
  {
    this.name = name.toUpperCase();
  }

/**
 * Lesen des Bootsnamen.
 */
  public String getName()
  {
    return name;
  }

/**
 * Ermitteln des Bootstyp.
 */
  public String getTyp()
  {
    return getClass().getName();
  }

/**
 * Abbremsen des Bootes, abstrakt.
 * @param delta Zielgeschwindigkeit
 */
  public abstract void bremsen( int delta);

/**
 * Beschreibung eines Bootes.
 */
  public String toString()
  {
    String str = "Bootstyp:     " + getTyp();
    str += "\nBootsname:    \"" + name + "\"";
    str += "\nNummer:       " + nummer;
    str += "\nBootsanzahl:  " + anzahl;
    return str;
  }
}
