// PaddelBoot.java                              MM 2005

/**
 * Paddelboot, Beispiel fuer abgeleitete Klassen.
 */
public class PaddelBoot extends Boot
{
/*---------------------------------------------------*/
                                     // Instanzvariable
/**
 * Paddelanzahl.
 */
  private int paddel;

/*---------------------------------------------------*/
                                       // Konstruktoren
/**
 * Konstuktor,
 * erzeugt Paddelboot mit Namen und Paddelanzahl.
 * @param name Name des Bootes
 * @param paddel Paddelanzahl
 */
  public PaddelBoot( String name, int paddel)
  {
    super( name);
    setPaddel( paddel);
  }

/**
 * Konstuktor,
 * erzeugt Paddelboot mit Paddelanzahl.
 * @param paddel Paddelanzahl
 */
  public PaddelBoot( int paddel)
  {
    this( "", paddel);
  }

/**
 * Konstuktor,
 * erzeugt Paddelboot mit Namen und einem Paddel.
 * @param name Name des Bootes
 */
  public PaddelBoot( String name)
  {
    this( name, 1);
  }

/**
 * Konstuktor,
 * erzeugt Paddelboot mit einem Paddel.
 */
  public PaddelBoot()
  {
    this( "", 1);
  }

/*---------------------------------------------------*/
                                     // Instanzmethoden
/**
 * Festlegen der Paddelanzahl.
 * @param paddel Paddelanzahl (1, 2 oder 4)
 */
  public void setPaddel( int paddel)
  {
    if( paddel == 2 || paddel == 4)
      this.paddel = paddel;
    else
      this.paddel = 1;
  }

/**
 * Ermitteln der Paddelanzahl.
 */
  public int getPaddel()
  {
    return paddel;
  }

/**
 * Abbremsen eines Paddelbootes,
 * ueberschreibt abstrakte Methode.
 * @param delta Zielgeschwindigkeit
 */
  public void bremsen( int delta)
  {
    System.out.println
    ( "Boot " + getName() + ": Paddel einziehen!");
  }

/**
 * Beschreibung eines Paddelbootes,
 * verwendet Stringbeschreibung eines Bootes.
 */
  public String toString()
  {
    String str = super.toString();
    str += "\nPaddelanzahl: " + paddel;
    return str;
  }

/*---------------------------------------------------*/
                       // Klassenkonstante als Referenz
/**
 * SCHIFFS_WRACK, untergegangenes Paddelboot.
 */
  public static final PaddelBoot SCHIFFS_WRACK;

  static                   // statischer Initialisierer
  {
    SCHIFFS_WRACK = new PaddelBoot( "Schiffswrack Eva", 4);
  }
}
