// BruchAddierer.java                           MM 2007
// MVC-Model

import java.util.*;                       // Observable

/**
 * Additor fuer gemeine Brueche.
 */
public class BruchAddierer
  extends Observable
{
/* --------------------------------------------------*/
                                            // coreData
/**
 * Aktueller Bruch.
 */
  private Bruch bruch;

/**
 * Bruchoperand.
 */
  private Bruch operand;

/* ------------------------------------------------- */
                                         // Konstruktor
/**
 * Konstruktor, setzt Startwerte auf 0/1.
 */
  public BruchAddierer()
  {
    reset();
  }


/* --------------------------------------------------*/
                                    // getData-Methoden
/**
 * Lese Bruch.
 */
  public Bruch getBruch()
  {
    return bruch;
  }

/**
 * Lese Zaehler.
 */
  public int getOperandZaehler()
  {
    return operand.getZaehler();
  }

/**
 * Lese Nenner.
 */
  public int getOperandNenner()
  {
    return operand.getNenner();
  }

/* ------------------------------------------------- */
                                    // Service-Methoden
// Eingaben
/**
 * Setze Zaehler vom Operand.
 */
  public void setOperandZaehler( int z)
  {
    operand.setZaehler( z);
  }

/**
 * Setze Nenner vom Operand.
 */
  public void setOperandNenner( int n)
  throws Exception
  {
    operand.setNenner( n);
  }

// Operationen
/**
 * Startzustand, loesche Bruch und Operand (C).
 */
  public void reset()
  {
    bruch = new Bruch( 0);
    operand = new Bruch( 0);

    setChanged();                 // Aenderung anzeigen
    notifyObservers();
  }

/**
 * Addition (+), setzt Addition fort.
 */
  public void add()
  throws Exception
  {
    bruch = bruch.add( operand);
    operand = new Bruch( 0);

    setChanged();                 // Aenderung anzeigen
    notifyObservers();
  }

/* ------------------------------------------------- */
/**
 * Darstellung des aktuellen Bruchs.
 */
  public String toString()
  {
    return bruch.toString() + "\t" + operand.toString();
  }

/* ------------------------------------------------- */
/* ------------------------------------------------- */
/**
 * Testprogramm zur Klasse BruchAddiererModel.
 * Aufgabe: 1/2+1/2+1/2+2/3=13/6
 */
  public static void main( String[] args)
  {
    try
    {
      BruchAddierer additor = new BruchAddierer();

// Startwerte
      System.out.println( "\t\tSumme\tOperand");
      System.out.println( "Startwerte");
      System.out.println( "\t\t" + additor);

// Aufgabe
      System.out.println
      ( "\nAufgabe: 1/2+1/2+1/2+2/3=13/6");
      System.out.println( "add 3 x 1/2");
      additor.setOperandZaehler( 1);
      additor.setOperandNenner( 2);
      System.out.println( "\t\t" + additor);
      additor.add();
      additor.setOperandZaehler( 1);
      additor.setOperandNenner( 2);
      System.out.println( "\t\t" + additor);
      additor.add();
      additor.setOperandZaehler( 1);
      additor.setOperandNenner( 2);
      System.out.println( "\t\t" + additor);
      additor.add();

      System.out.println( "add 2/3");
      additor.setOperandZaehler( 2);
      additor.setOperandNenner( 3);
      System.out.println( "\t\t" + additor);
      additor.add();
      System.out.println( "\t\t" + additor);
    }
    catch( Exception e)
    {
      System.out.println( "Fehler: " + e);
    }
  }
}
