//ChatClient.java                               MM 2011

import java.io.*;                          // Exception
import java.net.*;                            // Socket

/**
 * Client fuer Chatroom,
 * erzeugt Client-Socket fuer Kommunikation
 * mit angegebenen Server ber angegebenen Port
 * und wickelt Protokoll ab.
 * Aufruf: java ChatClient <Host> <Port>
 */
class ChatClient
{
  public static void main( String[] args)
  {
    try
    {
// Serververbindung
      String hostName = args[ 0];
      int port = Integer.parseInt( args[ 1]);
      Socket c = new Socket( hostName, port);
      System.out.println( "ChatClient laeft");

// Protokoll
      new ChatClientProtokoll( c).action();
    }
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.out.println
      ( "\nAufruf: java ChatClient <Host> <Port>\n");
    }
    catch( UnknownHostException e)
    {
      System.out.println
      ( "\nKein DNS-Eintrag fuer " + args[ 0] + "\n");
    }
    catch( Exception e)
    {
      System.out.println
      ( "\nVerbindung zum Server fehlgeschlagen\n  " + e);
    }
  }
}