// ChatModel.java                               MM 2011

import java.util.*;                       // Observable

/**
 * Model fuer Chatroom, speichert letzte Nachricht.
 */
public class ChatModel
  extends Observable
{
                                            // coreData
/**
 * Zuletzt gesendete Nachricht bzw. Startnachricht.
 */
  private String nachricht = "Chatroom leer";

/* ------------------------------------------------- */
                                    // getData-Methoden
/**
 * Lesen der Nachricht.
 * @return Nachricht
 */
  public String getNachricht()
  {
    return nachricht;
  }

/* ------------------------------------------------- */
                                    // service-Methoden
/**
 * Schreiben der Nachricht, synchronisiert.
 * @param n empfangene Nachricht
 */
  public synchronized void setNachricht( String n)
  {
    nachricht = n;

    setChanged();                  // Aenderungsmeldung
    notifyObservers( nachricht);
  }
}