// DoubleListe.java                             MM 2012

import Tools.IO.*;
import java.util.*;               // Collection-Klassen

/**
 * Doubleliste mit Ein- und Ausgabe.
 */
public class DoubleListe
{
/**
 * Liste von Objekten eines Typs Double.
 */
  protected List<Double> liste;

/**
 * Konstruktor, legt Typ und Art der Liste fest.
 */
  public DoubleListe( List<Double> liste)
  {
    this.liste = liste;
  }

/**
 * Fuellen einer Liste.
 */
  public void eingabeListe()
  {
    while( true)
    {
      String eingabe = IOTools.readLine
      ( "Naechste Komponente(<ENTER> fuer Abbruch) ");

      if( eingabe.equals( "")) break;

      try
      {
        liste.add( Double.valueOf( eingabe));
      }
      catch( Exception e)
      {
        System.out.println
        ( "Nur Zahlen eingeben!\n" + e);
      }
    }
  }

/**
 * Ausgabe einer Liste, 4 Version.
 */
  public void ausgabeListe()
  {
// 1. Version: For
    for( Double d: liste) System.out.print( " " + d);
    System.out.println();

/*
// 2. Version: Iterator
    Iterator<Double> it = liste.iterator();
    while( it.hasNext())
      System.out.print( " " + it.next());
    System.out.println();

// 3. Version: Get
    for( int i = 0; i < liste.size(); i++)
      System.out.print( " " + liste.get( i));
    System.out.println();

// 4. Version ListIterator
    ListIterator<Double> itNf
    = liste.listIterator( 0);
    ListIterator<Double> itVg
    = liste.listIterator( liste.size());
    while( itNf.hasNext())
      System.out.print( " " + itNf.next());
    System.out.println();
    while( itVg.hasPrevious())
       System.out.print( " " + itVg.previous());
    System.out.println();
*/
  }

/**
 * Test der List-Klassen
 * ArrayList, Vector, Stack, LinkedList.
 */
  public static void main( String[] args)
  {
    DoubleListe doubleListe;

// ArrayList
    System.out.println( "ArrayList");
    doubleListe
    = new DoubleListe( new ArrayList<Double>());
    doubleListe.eingabeListe();
    doubleListe.ausgabeListe();

// Vector
    System.out.println( "Vector");
    doubleListe
    = new DoubleListe( new Vector<Double>());
    doubleListe.eingabeListe();
    doubleListe.ausgabeListe();

// Stack
    System.out.println( "Stack");
    doubleListe
    = new DoubleListe( new Stack<Double>());
    doubleListe.eingabeListe();
    doubleListe.ausgabeListe();

// LinkedList
    System.out.println( "LinkedList");
    doubleListe
    = new DoubleListe( new LinkedList<Double>());
    doubleListe.eingabeListe();
    doubleListe.ausgabeListe();
  }
}