// DNSAnfrage.java                              MM 2005

import java.net.*;                        // InetAdress

/**
 * Ermittelt IP-Adresse bzw. Hostname.
 * Aufruf: java DNSAnfrage <Hostname>
 * oder:   java DNSAnfrage <IP-Adresse>
 */
class DNSAnfrage
{
  public static void main( String[] args)
  {
    try
    {
      InetAddress ip =
        InetAddress.getByName( args[ 0]);
      System.out.println
      ( "Angefragter Name: " + args[ 0]);
      System.out.println
      ( "IP-Adresse:       " + ip.getHostAddress());
      System.out.println
      ( "Host-Name:        " + ip.getHostName());
    }
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.out.println
      ( "Aufruf: java DNSAnfrage <Hostname>");
      System.out.println
      ( "oder:   java DNSAnfrage <IP-Adresse>");
    }
    catch( UnknownHostException e)
    {
      System.out.println
      ( "Kein DNS-Eintrag fuer " + args[ 0]);
    }
  }
}
