// DoubleDatei.java                                 MM 2012
import java.io.*;              // InputStream, OutputStream

/**
 * Programm schreibt und liest Double-Werte
 * in bzw. aus einer Datei.
 */
public class DoubleDatei
{
/**
 * Liest Double-Werte aus einer Datei
 * und schreibt sie auf der Konsole aus.
 */
  public void leseAusDoubleDatei( File datei)
    throws Exception
  {
    DataInputStream inDatei = null;

    try
    {
      inDatei =              // Eingabedatenstrom auf datei
      new DataInputStream(new FileInputStream( datei));

      while( true)
      {
                               // Lesen eines Double-Wertes
        double zahl = inDatei.readDouble();

               // Schreiben eines Double-Wertes auf Konsole
        System.out.println( "" + zahl);
      }
    }
                                // Fehler beim Zahlenformat
    catch( NumberFormatException e)
    {
      System.err.println
      ( "Auf der Datei befinden sich Nicht-Double-Werte!");
    }
                // Dateiende erreicht, Schliessen der Datei
    catch ( EOFException e){}

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler beim Schreiben!");
      throw e;
    }

    finally                             // Aufraeumarbeiten
    {
      try
      {                        // Schliessen der Dateidatei
        if( inDatei != null) inDatei.close();
      }
      catch( IOException e)
      {
        System.err.println
        ( "Fehler beim Schlieen der Datendatei!" );
      }
    }
  }

/**
 * Liest Double-Werte von der Tastatur
 * und schreibt sie in eine Datei.
 */
  public void schreibeInDoubleDatei( File datei)
    throws Exception
  {
    DataOutputStream outDatei = null;

    try
    {               // Tastatureingabedatenstrom, gepuffert
      BufferedReader inBuffer =
      new BufferedReader( new InputStreamReader( System.in));

      outDatei =             // Ausgabedatenstrom auf datei
      new DataOutputStream(new FileOutputStream( datei));

                // Eingabe eines Double-Wertes von Tastatur
      String zeile = inBuffer.readLine();

      while( !zeile.equals( ""))
      {
        try
        {       // Schreiben des Double-Wertes in die Datei
          double zahl = Double.parseDouble( zeile);
          outDatei.writeDouble( zahl);
        }
                                // Fehler beim Zahlenformat
        catch( NumberFormatException e)
        {
          System.err.println( "Nur Double-Werte eingeben!");
         }
                 // Eingabe eines Double-Werts von Tastatur
        zeile = inBuffer.readLine();
      }
    }

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler beim Schreiben!");
      throw e;
    }

    finally                             // Aufraeumarbeiten
    {
      try
      {                        // Schliessen der Dateidatei
        if( outDatei != null) outDatei.close();
      }
      catch( IOException e)
      {
        System.err.println
        ( "Fehler beim Schlieen der Datendatei!" );
      }
    }
  }

/**
 * Testprogramm.
 */
  public static void main( String[] args)
  {
    DoubleDatei daten = new DoubleDatei();

    try
    {
      File datei = new File( args[ 0]);

      System.out.print( "Double-Werte schreiben ");
      System.out.println( "(Abbruch mit ENTER): ");
      daten.schreibeInDoubleDatei( datei);

      System.out.println( "Double-Werte lesen: ");
      daten.leseAusDoubleDatei( datei);

    }
                               // Befehl nicht vollstaendig
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.err.println
      ( "Aufruf: java DoubleDatei <Zieldatei>");
    }
    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler: " + e);
    }

    System.out.println( "Fertig!");
  }
}