// FileInfo.java                                    MM 2004
import java.io.*;                                   // File

/**
 * Programm ermittelt Datei/Verzeichnis-Eigenschaften
 * Aufruf: java FileInfo <Verzeichnis>|<Datei>
 */
public class FileInfo
{
  public static void main( String[] args)
  {
    try
    {                               // File-Objekt erzeugen
      File datei = new File( args[ 0]);

      if( datei.exists())   // Datei-Eigenschaften abfragen
      {
        if( datei.isFile())
        {
          System.out.println
          ( "Datei " + args[ 0] + ": Datei");

          System.out.println
          ( "kompletter Pfad: " + datei.getAbsolutePath());
          System.out.println
          ( "Datei:           " + datei.getName());
          System.out.println
          ( "Leserecht:       " + datei.canRead());
          System.out.println
          ( "Schreibrecht:    " + datei.canWrite());
        }
                      // Verzeichnis-Eigenschaften abfragen
        if( datei.isDirectory())
        {
          System.out.println
          ( "Datei " + args[ 0] + ": Verzeichnis");

          String[] dateien = datei.list();
          for( int i = 0; i < dateien.length; i++)
            System.out.println( dateien[ i]);
        }
      }
      else
                       // Datei/Verzeichnis existiert nicht
      System.out.println
        ( "Datei " + args[ 0] + " nicht gefunden.");
    }
                               // Befehl nicht vollstaendig
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.err.println
      ( "Aufruf: java FileInfo <Verzeichnis>|<Datei>");
    }

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler: " + e);
    }

    System.out.println( "Fertig!");
  }
}