// Mitarbeiter.java                             MM 2003

/**
 * Mitarbeiter, abstrakte Klasse.
 */
public abstract class Mitarbeiter
{
/*---------------------------------------------------*/
                                         // Konstruktor
/**
 * Konstuktor, erzeugt neuen Mitarbeiter.
 * @param name Name des Mitarbeiters
 */
  public Mitarbeiter( String name)
  {
    incAnzahl();
    persNr = anzahl;
    this.name = name;
  }

/*---------------------------------------------------*/
                                     // Klassenvariable
/**
 * Mitarbeiteranzahl, legt naechste Personalnummer fest.
 */
  private static int anzahl = 0;

/*---------------------------------------------------*/

/**
 * Klassenmethode, Erhoehen der Mitarbeiterzahl.
 */
  private static void incAnzahl()
  {
    anzahl++;
  }
                                      // Instanzmethode

/*---------------------------------------------------*/
                                    // Instanzvariablen
/**
 * Personalnummer.
 */
  private int persNr;

/**
 * Name, bestehend aus Vor- und Nachnamen.
 */
  private String name;

/*---------------------------------------------------*/
                                     // Instanzmethoden
/**
 * Berechnung des Monatsbruttolohns, abstrakt.
 */
  public abstract double monatsBrutto();

/**
 * Ermitteln des Anstellungsverhaeltnisses.
 */
  public String getTyp()
  {
    return getClass().getName();
  }

/*---------------------------------------------------*/

/**
 * Beschreibung eines Mitarbeiters.
 */
  public String toString()
  {
    String str =  "Name: " + name;
    str += "\nPersonalnummer: " + persNr;
    str += "\tAnstellung: " + getTyp();
    str += "\tBruttolohn: " + monatsBrutto();
    return str;
  }

}
