// Koordinate.java                              MM 2011

/**
 * Koordinaten eines kartesischen Koordinatensystems.
 */
public class Koordinate
{
/* ------------------------------------------------- */
                                            // coreData
/**
 * x-Wert der Koordinate.
 */
  private double x;

/**
 * y-Wert der Koordinate.
 */
  private double y;

/* ------------------------------------------------- */
                                       // Konstruktoren
/**
 * Konstruktor, setzt x- und y-Wert der Koordinate.
 * @param x x-Koordinate
 * @param y y-Koordinate
 */
  public Koordinate( double x, double y)
  {
     this.x = x;
     this.y = y;
  }

/**
 * Konstruktor, kopiert eine Koordinate.
 * @param k Koordinate
 */
  public Koordinate( Koordinate k)
  {
     this( k.getX(), k.getY());
  }

/* ------------------------------------------------- */
                                     //getData-Methoden
/**
 * Lesen des x-Wertes der Koordinate.
 * @return x-Koordinate
 */
  public double getX()
  {
    return x;
  }

/**
 * Lesen des y-Wertes der Koordinate.
 * @return y-Koordinate
 */
  public double getY()
  {
    return y;
  }

/* ------------------------------------------------- */
                                    // Service-Methoden
/**
 * Abstand zu einer weiteren Koordinate.
 * @param k Koordinate
 * @return Abstand zwischen beiden Koordinaten
 */
  public double getAbstand( Koordinate k)
  {
     double dx, dy;
     dx = k.getX() - this.x;
     dy = k.getY() - this.y;
     return Math.sqrt( dx * dx + dy * dy);
  }

/**
 * Beschreiben der Koordinate.
 */
  public String toString()
  {
    return "( " + x + ", " + y + ")"; 
  }

/* ------------------------------------------------- */
/* ------------------------------------------------- */
/**
 * Testprogramm:
 * Pythagoreisches Zahlentripel(3, 4, 5).
 * Ausgabe: Abstand 5.0 bzw. Abstand 0.0
 */
  public static void main( String[] args)
  {
    Koordinate koord0 = new Koordinate( 1, 2);
    Koordinate koord1 = new Koordinate( 5, 5);
    Koordinate koord2 = new Koordinate( koord1);

    System.out.println( "koord0 = " + koord0);
    System.out.println( "koord1 = " + koord1);
    System.out.println( "koord2 = " + koord2);

    System.out.println
    ( "Abstand " + koord0.getAbstand( koord1));
    System.out.println
    ( "Abstand " + koord0.getAbstand( koord2));
    System.out.println
    ( "Abstand " + koord2.getAbstand( koord2));
  }
}
