//Behaelter.java                                MM 2007

/**
 * Behaelter (Kanne oder Eimer).
 */
public class Behaelter
{
/* ------------------------------------------------- */
// Attribute
/**
 * Inhalt.
 */
  private int inh;

/**
 * Volumen.
 */
  private int max;

/* ------------------------------------------------- */
// Konstruktor
/**
 * Konstruktor, erzeugt Behaelter.
 * @param m maximales Fassungsvermoegen
 */
  public Behaelter( int m)
  {
    max = m; inh = 0;
  }

/* ------------------------------------------------- */
// Service-Methoden
/**
 * Vergleicht Inhalt mit Soll.
 * @param soll gewuenschte Fuellmenge.
 */
  public boolean istInhSoll( int soll)
  {
    return inh == soll;
  }

/**
 * Behaelter ist voll.
 */
  public boolean istVoll()
  {
    return inh == max;
  }

/**
 * Behaelter ist leer.
 */
  public boolean istLeer()
  {
    return inh == 0;
  }

/**
 * Behaelter wird geleert.
 */
  public void leeren()
  {
    inh = 0;
  }

/**
 * Behaelter wird gefuellt, bis er voll ist.
 */
  public void fuellen()
  {
    inh = max;
  }

/**
 * Behaelter nimmt Inhalt eines anderen Behaelters auf.
 * @param b anderer Behaelter
 */
  public int eingiessenAus( Behaelter b)
  {
    int liter = b.ausgiessenIn( this);
    inh += liter;
    return liter;
  }

/**
 * Inhalt des Behaelters wird
 * in einen anderen Behaelter gegossen.
 * @param b anderer Behaelter
 */
  private int ausgiessenIn( Behaelter b)
  {
    int liter = b.leerPlatz();
    if (liter > inh) liter = inh;
    inh -= liter;
    return liter;
  }

/**
 * Restlicher Platz im Behaelter.
 */
  private int leerPlatz()
  {
    return max - inh;
  }

/* ------------------------------------------------- */
// Zugriffsmethoden
/**
 * Liest aktuelle Fuellmenge.
 */
  public int getInh()
  {
    return inh;
  }

/**
 * Liest maximale Fuellmenge.
 */
  public int getMax()
  {
    return max;
  }

/**
 * Beschreibt Zustand des Behaelters.
 */
  public String toString()
  {
    return inh + " von "+ max;
  }
}
