// Obst.java                                        MM 2007
import java.io.*;                           // Serializable

/**
 * Klasse (abstrakt) Obst verwaltet fuer verschiedene
 * Obstarten, deren Namen und ihre Pflueckreife.
 */
public abstract class Obst implements Serializable
{
/**
 * Obstsorte.
 */
  private String name;

/**
 * Pflueckreife (Erntemonat).
 */
  private int pflueckReife;

/* ----------------------------------------------------- */
/**
 * Konstuktor Obst.
 * @param name Obstsorte
 * @param pr   Pflueckreife (Erntemonat)
 */
  protected Obst( String name, int pr)
  {
    this.name = name;
    pflueckReife = pr;
  }

/**
 * Beschreibt Obstsorte.
 */
  public String toString()
  {
     return
       "" + name +
       "\t - " + getClass().getName() +
       "\t - PR (Monat): " + pflueckReife;
  }
}

/* ----------------------------------------------------- */
/**
 * Birne.
 */
class Birne extends Obst
{
//  private static final long serialVersionUID = 1L;

/**
 * Konstuktor Birne.
 * @param name Obstsorte
 * @param pr   Pflueckreife (Erntemonat)
 */
  public Birne( String name, int pr)
  {
    super( name, pr);
  }
}

/* ----------------------------------------------------- */
/**
 * Pflaume.
 */
class Pflaume extends Obst
{
//  private static final long serialVersionUID = 2L;

/**
 * Konstuktor Pflaume.
 * @param name Obstsorte
 * @param pr   Pflueckreife (Erntemonat)
 */
  public Pflaume( String name, int pr)
  {
    super( name, pr);
  }
}

/* ----------------------------------------------------- */
/**
 * Apfel.
 */
class Apfel extends Obst
{
//  private static final long serialVersionUID = 3L;

/**
 * Konstuktor Apfel.
 * @param name Obstsorte
 * @param pr   Pflueckreife (Erntemonat)
 */
  public Apfel( String name, int pr)
  {
    super( name, pr);
  }
}

/* ----------------------------------------------------- */
/**
 * Winterapfel, hat eine Lagerzeit.
 */
class WinterApfel extends Apfel
{
//  private static final long serialVersionUID = 4L;
/**
 * Lagerzeit des Apfels (in Monaten).
 */
  private int lagerZeit;

/**
 * Konstuktor Obst.
 * @param name Obstsorte
 * @param pr   Pflueckreife (Erntemonat)
 * @param zeit Lagerzeit des Apfels (in Monaten)
 */
  public WinterApfel( String name, int pr, int zeit)
  {
    super( name, pr);
    lagerZeit = zeit;
  }

/**
 * Beschreibt Winterapfel.
 */
  public String toString()
  {
     return super.toString()
       + "\t - LZ(Monate): " + lagerZeit;
  }
}
