// ObstMain.java                                    MM 2012
import java.io.*;                                   // File
import java.util.*;                               // Vector

/**
 * Testprogramm fuer die Klassen Obst und ObjektDatei.
 */
public class ObstMain
{ 
  public static void main( String[] args)
  {
/* ----------------------------------------------------- */
                                                  // Aepfel
      Obst apfel =
      new Apfel( "Weisser KlarApfel    ", 7);
      Obst winterApfel1 =
      new WinterApfel( "Roter Boskoop        ", 10, 5);
      Obst winterApfel2 =
      new WinterApfel( "Kaiser Wilhelm       ", 10, 5);
      Obst winterApfel3 =
      new WinterApfel( "Roter Jonathan       ", 9, 7);

                                                  // Birnen
      Obst birne1 =
      new Birne( "Clapps Liebling      ", 8);
      Obst birne2 =
      new Birne( "Gelbe Wiiliams Christ", 8);
      Obst birne3 =
      new Birne( "Gute Luise           ", 10);

                                                // Pflaumen
      Obst pflaume1 =
      new Pflaume( "Hauszwetsche         ", 9);
      Obst pflaume2 =
      new Pflaume( "Koenigin Viktoria    ", 8);
      Obst pflaume3 =
      new Pflaume( "Ontariopflaume       ", 7);

/* ----------------------------------------------------- */
                                               // Obstdatei
    ObjektDatei<Obst> obstDatei = new ObjektDatei<Obst>();

    File datei = new File( "Obst.obj");
    File dateiKopie = new File( "ObstKopie.obj");

    try
    {
      System.out.println( "Schreiben der Datei");

      try
      {
                                       // Schreibe in Datei
        obstDatei.schreibeInObjektDatei( datei, apfel);
        obstDatei.schreibeInObjektDatei
                                ( datei, winterApfel1);
        obstDatei.schreibeInObjektDatei
                                ( datei, winterApfel2);
        obstDatei.schreibeInObjektDatei
                                ( datei, winterApfel3);
        obstDatei.schreibeInObjektDatei( datei, birne1);
        obstDatei.schreibeInObjektDatei( datei, birne2);
        obstDatei.schreibeInObjektDatei( datei, pflaume1);
        obstDatei.schreibeInObjektDatei( datei, pflaume2);

        obstDatei.schreibeInObjektDatei( datei, birne3);
        obstDatei.schreibeInObjektDatei( datei, pflaume3);
      }

      catch( Exception e)     // Fehlerbehandlung allgemein
      {
        System.err.println( "Fehler beim Schreiben! + e");
        return;
      }

      System.out.println( "Schreiben abgeschlossen!\n");

/* ----------------------------------------------------- */
                                        // Kopiere in Datei
      System.out.println( "Kopieren der Datei");

      try
      {
        obstDatei.kopiereObjektDatei( datei, dateiKopie);
      }

      catch( Exception e)     // Fehlerbehandlung allgemein
      {
        System.err.println( "Fehler beim Kopieren! + e");
        return;
      }

      System.out.println( "Kopieren abgeschlossen!\n");

/* ----------------------------------------------------- */
                                          // Lese aus Datei
      Vector obst = new Vector();
      obst.clear();

      System.out.println( "Lesen der Kopie");

      try
      {
        obstDatei.leseAusObjektDatei( dateiKopie, obst);
        obstDatei.listeObjekte( obst);
      }

      catch( Exception e)     // Fehlerbehandlung allgemein
      {
        System.err.println( "Fehler beim Lesen! + e");
        return;
      }

      System.out.println( "Lesen abgeschlossen!\n");

/* ----------------------------------------------------- */
                  // Zugiff auf Lagerzeit von Winteraepfeln
      System.out.println( "Winteraepfel");

      for( int i = 0; i < obst.size(); i++)
      {
        if(obst.get(i).getClass().getName()=="WinterApfel")
          System.out.println((WinterApfel)obst.get(i));
      }
    }

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( e);
    }

/* ----------------------------------------------------- */
    finally                             // Aufraeumarbeiten
    {                           // Loeschen der Obstdateien
      datei.delete();
      dateiKopie.delete();
    }
  }
}
