// SimplePanel.java                             MM 2004
//                                              AZ 2004

import java.awt.*;                    // Color Graphics
import java.awt.geom.*;              // AffineTransform
import javax.swing.*;                         // JPanel

/**
 * Darstellung einer simplen Grafik
 */
public class SimplePanel
  extends JPanel
{
/**
 * Konstruktor, legt bevorzugte Groesse des 
 * Darstellungsbereiches fest.
 * @param dimX Breite
 * @param dimY Hoehe
 */
  SimplePanel( int dimX, int dimY) 
  {
    setPreferredSize( new Dimension( dimX, dimY));
  }

/**
 * Zeichnen von Grafikobjekten.
 */
  public void paint( Graphics g) 
  {
// Leeren des Darstellungsbereich
    g.setColor( getBackground());
    g.fillRect( 0, 0, getWidth(), getHeight());

// String-Ausgabe
    g.setColor( Color.red);
    g.setFont( new Font( "serif", Font.ITALIC, 30));
    g.drawString( "Simple Graphic", 20, 80);

// Rechteck
    g.setColor( Color.green);
    g.drawRect( 20, 90, 170, 150);

// Dreieck (gefllt)
    int[] x= { 100, 150, 200};
    int[] y= { 270, 180, 250};
    g.setColor( Color.red);
    g.fillPolygon( x, y, 3);

// Kreis
   g.setColor( Color.blue);
   g.drawOval( 200, 170, 90, 90);

// Linie
   g.setColor( Color.magenta);
   g.drawLine( 10, 160, 290, 140);

// Bild
    MediaTracker tracker = new MediaTracker( this);
    Image bild = Toolkit.getDefaultToolkit().getImage
                                      ( "unilogo.gif");
    tracker.addImage( bild, 0);
    try
    {
      tracker.waitForAll();
    }
    catch( InterruptedException e)
    {
      throw new Error( "Konnte Bild nicht laden!");
    }
    g.drawImage( bild, 100, 0, null);  

// Rechteck (gedreht) mit 2D Grafik
    g.setColor( Color.blue);
    Graphics2D g2d = (Graphics2D)g;
                                             // Drehung
    AffineTransform at = g2d.getTransform();
    g2d.setTransform
    ( AffineTransform.getRotateInstance
      ( Math.PI/3, 150, 150));
    g2d.draw( new Rectangle( 20, 90, 170, 150));
                                    // Drehung aufheben
    g2d.setTransform( at);
  }
}
