// Ziffer.java                                  MM 2007
//                                              AZ 2004

/**
 * Ziffer als ganze Zahlen zwischen 0 und 9.
 */
public class Ziffer
{
/**
 * Wert der Ziffer.
 */
  private int value;

/* ------------------------------------------------- */
/**
 * Konstruktor,
 * setzt den Wert der Ziffer zwischen 0 und 9.
 * @param value Wert der Ziffer
 */
  public Ziffer( int value)
  {
    this.value = value % 10;
  }

/**
 * Konstruktor,
 * bernimmt den Wert der Ziffer.
 * @param z Ziffer
 */
  public Ziffer( Ziffer z)
  {
    value = z.value;
  }

/* ------------------------------------------------- */
/**
 * Vergleich mit einer Ziffer.
 * @param z Ziffer
 * @return true bei Gleichheit
 */
  public boolean equals( Ziffer z)
  {
    return value == z.value;
  }

/**
 * Addition (mod 10) mit Ziffer und Uebertrag.
 * @param z Ziffer
 * @param uebertrag Uebertrag (0 oder 1)
 * @return Uebertrag
 */
  public int add( Ziffer z, int uebertrag)
  {
    int v = value + z.value + uebertrag;
    value = v % 10;
    return v / 10;
  }

/* ------------------------------------------------- */
/**
 * Darstellung der Ziffer.
 * @return Wert der Ziffer als String
 */
  public String toString()
  {
    return "" + value;
  }

/* ------------------------------------------------- */
/**
 * Test der Klasse Ziffer.
 */
  public static void main( String[] args)
  {
    Ziffer z1 = new Ziffer( 7);
    Ziffer z2 = new Ziffer( z1);

// Vergleich z1 mit z2
    if( z1.equals( z2))
      System.out.println( "Ziffern identisch");
    else
      System.out.println( "Ziffern nicht identisch");

// Adition
    System.out.print( z1 + "+" + z2);
    System.out.println( "=" + z1.add( z2, 0) + z1);

// Vergleich z1 mit z2
    if( z1.equals( z2))
      System.out.println( "Ziffern identisch");
    else
      System.out.println( "Ziffern nicht identisch");
  }
}