// TextKopie.java                                   MM 2012
import java.io.*;                         // Reader, Writer

/**
 * Ungepufferte Kopiermethode fuer Texte.
 * Aufruf: java TextKopie <Quelldatei> <Zieldatei>
 */
public class TextKopie
{
/**
 * Kopiert zeichenweise, ungepuffert.
 */
  public void kopieren( Reader in, Writer out)
    throws Exception
  {
    int zeichen;      // Lesen und Schreiben eines Zeichens
                              // -1 Datenstromende (^D, ^Z)
    while(( zeichen = in.read()) != -1)
      out.write( zeichen);
  }

/**
 * Testprogramm.
 */
  public static void main( String[] args)
  {
    TextKopie text = new TextKopie();

    Reader in = null;
    Writer out = null;

    try
    {                                  // Eingabedatenstrom
      in = new FileReader( new File( args[ 0]));
                                       // Ausgabedatenstrom
      out = new FileWriter( new File( args[ 1]));

      text.kopieren( in, out);                  // Kopieren
    }

                               // Befehl nicht vollstaendig
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.err.print( "Aufruf: ");
      System.err.println
      ( "java TextKopie <Quelldatei> <Zieldatei>");
    }

                               // Textdatei existiert nicht
    catch( FileNotFoundException e)
    {
      System.err.println
      ( "Die Datei >" + args[ 0] + "< existiert nicht!");
    }

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler: " + e);
    }

    finally                             // Aufraeumarbeiten
    {
      try
      {                       // Schliessen der Textdateien
        if( in != null) in.close();
        if( out != null) out.close();
      }
      catch( IOException e)
      {
        System.err.println
        ( "Fehler beim Schlieen der Dateien!" );
      }
    }

    System.out.println( "Fertig!");
  }
}