// TextKopieMitPuffer.java                          MM 2012
import java.io.*;                         // Reader, Writer

/**
 * Gepufferte Kopiermethode fuer Texte.
 * Aufruf:
 * java TextKopieMitPuffer <Quelldatei> <Zieldatei>
 */
public class TextKopieMitPuffer
{
/**
 * Kopiert zeilenweise, gepuffert.
 */
  public void kopieren
  ( BufferedReader inBuffer, BufferedWriter outBuffer)
    throws Exception
  {
    try
    {
      while( true)
      {                              // Lesen und Schreiben
        outBuffer.write( inBuffer.readLine());
        outBuffer.newLine();               // Zeilenwechsel
      }
    }

    catch( NullPointerException e){}  // Dateiende erreicht
  }

/**
 * Testprogramm.
 */
  public static void main( String[] args)
  {
    TextKopieMitPuffer text = new TextKopieMitPuffer();

    BufferedReader inBuffer = null;
    BufferedWriter outBuffer = null;

    try
    {
      inBuffer =            // Eingabedatenstrom, gepuffert
      new BufferedReader(new FileReader(new File(args[0])));

      outBuffer =           // Ausgabedatenstrom, gepuffert
      new BufferedWriter(new FileWriter(new File(args[1])));

      text.kopieren( inBuffer, outBuffer);      // Kopieren
    }
                               // Befehl nicht vollstaendig
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.err.print( "Aufruf: java ");
      System.err.println
      ( "TextKopieMitPuffer <Quelldatei> <Zieldatei>");
    }
                               // Textdatei existiert nicht
    catch( FileNotFoundException e)
    {
      System.err.println
      ( "Die Datei >" + args[ 0] + "< existiert nicht!");
    }

    catch( Exception e)       // Fehlerbehandlung allgemein
    {
      System.err.println( "Fehler: " + e);
    }

    finally                             // Aufraeumarbeiten
    {
      try
      {                       // Schliessen der Textdateien
        if( inBuffer != null) inBuffer.close();
        if( outBuffer != null) outBuffer.close();
      }
      catch( IOException e)
      {
        System.err.println
        ( "Fehler beim Schlieen der Dateien!" );
      }
    }

    System.out.println( "Fertig!");
  }
}